03贪心:摆动序列

03贪心:摆动序列

376. 摆动序列

局部最优:删除单调坡度上的节点(不包括单调坡度两端的节点),那么这个坡度就可以有两个局部峰值。

整体最优:整个序列有最多的局部峰值,从而达到最长摆动序列。

局部最优推出全局最优,并举不出反例,那么试试贪心!

实际操作上,其实连删除的操作都不用做,因为题目要求的是最长摆动子序列的长度,所以只需要统计数组的峰值数量就可以了(相当于是删除单一坡度上的节点,然后统计长度)

这就是贪心所贪的地方,让峰值尽可能的保持峰值,然后删除单一坡度上的节点

这是我们思考本题的一个大题思路,但本题要考虑三种情况:

  1. 情况一:上下坡中有平坡
  2. 情况二:数组首尾两端
  3. 情况三:单调坡中有平坡
java 复制代码
class Solution {//贪心:要想成为摆动序列,只需要吧每一条单调坡除峰值以外的其他元素删除即可(局部最优),那么整个数组就是摆动序列(整体最优)
    public int wiggleMaxLength(int[] nums) {
        //一般情况:prediff记录左边的方向,curdiff记录右边的方向,如果两值一正一负则result++
        int prediff = 0;
        int curdiff = 0;
        int result = 1;//@2
        /*几点特殊情况
        1.上下坡中有平坡
        1 2 2 1 prediff = 0,curdiff != 0 @1
        2.考虑首尾元素
        1 2 这是两个长度,假设数组是1 1 2,起始位置左边假设是个平坡,那么就满足第一种特殊情况可以加一,另外,总是假设数组的最右侧是一个长度,因为它必是一个峰值@2
        3.单调坡中有平坡
        1 2 2 3 (我们判断的是最后一个数字也就是第二个2)对于第二个2来说,prediff=0,curdiff!=0,应该算一个,但是并不是,因为这不是上下坡
        我们怎么知道不是呢,得通过prediff来判断,如果这个prediff记录的是1 2之间的坡度我就能判断出来这不是答案,也就是说prediff的更新下手解决
        解决办法:
        当坡度有变化的时候再进行更新,就是说result有变化的时候,坡度就肯定有变化
        回到第一种特殊情况,1 2 2 1prediff记录1 2 的坡度,curdiff记录的是2 1的坡度,符合
        */
        for(int i = 0; i < nums.length - 1; i++) {//因为假设最后一个数已经计算上了,res=1
            curdiff = nums[i + 1] - nums[i];
            //prediff * curdiff <= 0不行,这只能保证两个坡度至少有一个为0,如果是0 0的话就错了
            if((prediff <= 0 && curdiff > 0) || (prediff >= 0 && curdiff < 0)) {//@1   如果curdiff等于0就不用管了,向右遍历就可以了
                result++;
                prediff = curdiff;//@3
            }
            //prediff = curdiff;不用且不能实时更新
        }

        return result;
    }
}
相关推荐
没有钱的钱仔1 小时前
协方差矩阵含义
算法·机器学习·矩阵
垆边人似月.1 小时前
华为机试题 :和为 K 的子数组个数
算法·leetcode·华为
三*一1 小时前
优化修整算法
前端·javascript·算法
达子6662 小时前
RUST 图解 第 3 章:通用编程概念(Common Programming Concepts)
开发语言·算法·rust
夏幻灵2 小时前
每日一题:LeetCode 165:比较版本号
算法·leetcode·职场和发展
道尔柯南2 小时前
C++ 面向对象编程入门:类和对象(上)
开发语言·c++·算法
Navigator_Z2 小时前
LeetCode //C - 1288. Remove Covered Intervals
c语言·算法·leetcode
码爸3 小时前
决策树介绍与示例
python·算法·机器学习
动词ing3 小时前
【题目练习】字符串相乘
算法